=== debian/changelog ===
rhash (1.3.4-3) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Team upload (collab-maint).

  [ Helmut Grohne ]
  * Fix FTCBFS: (Closes: #870508)
    + Let dh_auto_build pass cross compilers to $(MAKE).
    + Honour DEB_BUILD_OPTIONS=nocheck.
    + Let dh_strip strip.

 -- Helmut Grohne <helmut@subdivi.de>  Wed, 02 Aug 2017 16:37:09 +0200

rhash (1.3.4-2) unstable; urgency=medium

  * Team upload (collab-maint).
  * Upload to unstable.
  * Bump std-version to 4.0.0

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 10 Jul 2017 15:54:30 +0200

rhash (1.3.4-1) experimental; urgency=medium

  * Team upload (collab-maint).
  * New upstream release (Closes: #810029, #835260)
  * Make watch file point to github.
  * Update std-version to 3.9.8, no changes required.
  * Bump compat level to 10
  * Make VCS fields in secure mode
  * Update libssl runtime dependencies
  * Follow upstream change and include .so in -dev package

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 22 May 2017 11:29:05 +0200
