=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/rhash-$1\.tar\.gz/ \
  https://github.com/rhash/RHash/tags .*/v?(\d\S*)\.tar\.gz
