## rhash 1.3.5

=== debian/changelog ===
rhash (1.3.5-1) unstable; urgency=low

  [ Aleksey Kravchenko ]
  * New upstream release version 1.3.5
  * Drop obsolete dbg package
  * Add test to autopkgtest
  * Hardenning: support bindnow
  * Bump Standards-Version to 4.1.3
  * Switch git links to the Salsa server
  * Change Maintainer to pkg-security team
  * Change copyright-format uri to https
  * Bump compat level to 11
  * Simplify the override_dh_auto_install rule

  [ Lukas Schwaighofer ]
  * Use DEB_BUILD_MAINT_OPTIONS = hardening=+all
  * Use DEB_CFLAGS_MAINT_APPEND variable
  * Remove unnecessary LD_LIB variable
  * Remove obsolete checking DEB_BUILD_OPTIONS for 'debug' and 'parallel'
  * Pass CPPFLAGS to compiler

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Thu, 01 Feb 2018 02:21:57 +0300
