=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: rhash
 Section: utils
 Priority: optional
-Maintainer: Aleksey Kravchenko <rhash.admin@gmail.com>
-Build-Depends: debhelper (>= 10), dpkg-dev (>= 1.16.2), libssl-dev (>= 1.0.0)
-Standards-Version: 4.0.0
+Maintainer: Debian Security Tools Packaging Team <pkg-security-team@lists.alioth.debian.org>
+Uploaders: Aleksey Kravchenko <rhash.admin@gmail.com>
+Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.16.2), libssl-dev (>= 1.0.0)
+Standards-Version: 4.1.3
 Homepage: http://rhash.sourceforge.net/
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/rhash.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/rhash.git
+Vcs-Git: https://salsa.debian.org/pkg-security-team/rhash.git
+Vcs-Browser: https://salsa.debian.org/pkg-security-team/rhash
 
 Package: rhash
 Architecture: any
@@ -57,16 +58,3 @@
  GOST R 34.11-94, RIPEMD-160, HAS-160, EDON-R, Whirlpool and Snefru.
  .
  This package contains LibRHash static library and header files.
-
-Package: librhash0-dbg
-Architecture: any
-Section: debug
-Priority: extra
-Depends: librhash0 (= ${binary:Version}), ${misc:Depends}
-Description: debugging symbols for librhash
- LibRHash is a professional, portable, thread-safe C library for computing
- magnet links and a wide variety of hash sums, such as CRC32, MD4, MD5, SHA1,
- SHA256, SHA512, AICH, ED2K, Tiger, DC++ TTH, BitTorrent BTIH,
- GOST R 34.11-94, RIPEMD-160, HAS-160, EDON-R, Whirlpool and Snefru.
- .
- This package contains debug information for the librhash shared library.
